class Sparkler{
  private float x;
  private float y;
  private float dx;
  private float dy;
  private float maxSize;
  private int maxTimeToLive;
  private int timeToLive;
  
  private int crackStep = 3;

  Sparkler(float x,float y, float size, int timeToLive){
    this.x = x;
    this.y = y;
    this.maxSize = size;
    this.timeToLive = timeToLive;
    this.maxTimeToLive = timeToLive;
  }
  protected void drawCrack(float x1, float y1, float angle, float n, float size){
    if (n > 0){
      float x2 = (x1 + (cos(angle * (PI/180)) * random(size)));
      float y2 = (y1 + (sin(angle * (PI/180)) * random(size)));
      line(x1, y1, x2, y2);
      drawCrack(x2, y2, angle, n - 1, size);
      drawCrack(x2, y2, angle, n - 1, size);
    }
  }
  
  public void moveRandom(HashMap<String,PVector> starPositions){
    int r = 2;
    x += random(r)-r/2;
    y += random(r)-r/2;
    PVector p = starPositions.get(int(x)+" "+int(y));
    if (p != null && p.z != 0){
      p.z = 0;
      this.timeToLive = this.maxTimeToLive;
    }
  }
  
  public boolean isAlive(){
    return this.timeToLive > 0;
  }
  
  public void drawSparkle(){
    if (! isAlive()){
      if (int(random(10)) == 0){
        ellipse(this.x, this.y, 1, 1);
      }
    }else{
      int cracks = 3;
      if (timeToLive == maxTimeToLive){
        stroke(colLineDepresive);
        cracks = 100;
      }
      for(int a = 0; a < cracks; a+=1){
        drawCrack(this.x,this.y,random(360),this.crackStep,maxSize*((float)timeToLive/maxTimeToLive));
      }
      this.timeToLive--;
      this.timeToLive = max(0,this.timeToLive);
    }
  }
}